using BrushUpTeacherValidatorUnitTest;
//using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace BrushUpTeacherValidatorUnitTestTests
{
    [TestClass]
    public class TeacherTests
    {
        private Teacher teacher = new Teacher { Id = 1, Name = "Henrik Hltzer", Salary = 1000 };
        private Teacher teacherNameNull = new Teacher { Id = 2, Name = null, Salary = 1000 };
        private Teacher teacherNameToShort = new Teacher { Id = 3, Name = "", Salary = 1000 };
        private Teacher teacherSalaryNegative = new Teacher { Id = 4, Name = "Henrik Hltzer", Salary = -1000 };

        [TestMethod]
        public void ToStringTest()
        {
            string str = teacher.ToString();
            Assert.AreEqual("{Id=1, Name=Henrik Hltzer, Salary=1000}", str);
        }

        [TestMethod]
        public void ValidateNameTest()
        {
            teacher.ValidateName();
            Assert.ThrowsException<ArgumentNullException>(() => teacherNameNull.ValidateName());
            Assert.ThrowsException<ArgumentException>(() => teacherNameToShort.ValidateName());
        }

        [TestMethod]
        public void ValidateSaleryTest()
        {
            teacher.ValidateSalary();
            Assert.ThrowsException<ArgumentOutOfRangeException>(() => teacherSalaryNegative.ValidateSalary());
        }


        //Bemrk dette er et alternativ til at benytte de to vrige ValidateTest metoder 
        [TestMethod]
        public void ValidateTest()
        {
            teacher.Validate();
            Assert.ThrowsException<ArgumentNullException>(() => teacherNameNull.Validate());
            Assert.ThrowsException<ArgumentException>(() => teacherNameToShort.Validate());
            Assert.ThrowsException<ArgumentOutOfRangeException>(() => teacherSalaryNegative.Validate());
        }
    }
}