﻿namespace RefactoredBrushUp
{
    //Bemærk hvis class Person er abstract kan der ikke laves unittest af klassen!
    //public abstract class Person
    public class Person : IPerson
    {
        //Bemærk her er valgt at definere "Unknown", som det 0'te element (default elementet - er Gender ikke initialiseret med en værdi, assignes det denne værdi)
        //Det er valgt for at tvinge stillingtagen til Gender og ikke auto-tildele værdien "Male" der ellers er det 0'te element
        public enum GenderType
        {
            Unknown, Male, Female
        }
        public int Id { get; set; }
        public string Name { get; set; }

        public GenderType Gender { get; set; }

        public void ValidateName()
        {
            // if (String.IsNullOrEmpty(Name)) throw new ArgumentException("Name is null or empty");

            if (Name == null) throw new ArgumentNullException("name is null");

            if (Name.Length < 1) throw new ArgumentException("name must be at least 1 character: " + Name);

        }

        //Bemærk normalt er det ikke nødvendigt at teste en enum - det gør compaileren. Det er således ikke muligt at tildele en ikke specificeret værdi
        //Her tester vi da vi ikke tillader "Male" som en default værdi. 

        public void ValidateGender()
        {
            if (Gender == 0) throw new ArgumentException("Gender is unknown - must be Male or Female");
        }

        public Person(int id, string name, GenderType gender)
        {
            Id = id;
            Name = name;
            Gender = gender;
        }

        public Person() { }

        public virtual void Validate()
        {
            ValidateName();
        }

        public override string ToString()
        {
            return $"{nameof(Id)}={Id.ToString()}, {nameof(Name)}={Name}, {nameof(Gender)}={Gender}";
        }

        public override bool Equals(object? obj)
        {
            return obj is Person person &&
                   Id == person.Id &&
                   Name == person.Name &&
                   Gender == person.Gender;
        }

        public override int GetHashCode()
        {
            return HashCode.Combine(Id, Name, Gender);
        }
    }
}