﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RefactoredBrushUp
{
    public class Teacher : Person, ITeacher
    {
        public int Salary { get; set; }
        public List<String> Classes { get; set; }



        public Teacher(int id, string name, GenderType gender, int salary, List<string> classes) : base(id, name, gender)
        {
            Salary = salary;
            Classes = classes;
        }

        public Teacher() : base()
        {
        }

        public void ValidateSalary()
        {
            if (Salary < 0) throw new ArgumentOutOfRangeException("Salery must be positive: " + Salary);
        }

        public void ValidateClasses()
        {
            if (Classes == null) throw new ArgumentNullException("Classes is null");
        }

        public override void Validate()
        {
            base.Validate();
            ValidateSalary();
            ValidateClasses();
        }
        //public override string ToString()
        //{
        //    return $"{{{base.ToString()}, {nameof(Salary)}={Salary.ToString()}}}";
        //}

        public override string ToString()
        {
            String classes = "[";
            foreach (var c in Classes)
            {
                classes += c + ", ";
            }
            classes = classes.Substring(0, classes.Length - 2);
            classes += "]";

            return $"{{{base.ToString()}, {nameof(Salary)}={Salary.ToString()}, {nameof(Classes)}={classes}}}";
        }

        public override bool Equals(object? obj)
        {
            return obj is Teacher teacher &&
                   base.Equals(obj) &&
                   Salary == teacher.Salary &&
                   //EqualityComparer<List<string>>.Default.Equals(Classes, teacher.Classes);     Bemærk: Den autogenererede linie virker ikke - se consol program
                   Classes.All(teacher.Classes.Contains) && teacher.Classes.All(Classes.Contains);


        }

        public override int GetHashCode()
        {
            //return HashCode.Combine(base.GetHashCode(), Salary, Classes); Bemærk den autogenererede HashCode() Virker ikke!!
            return HashCode.Combine(base.GetHashCode(), Salary);
        }
    }
}
