﻿using RefactoredBrushUp;

namespace RefactoredBrushUpTests
{
    [TestClass]
    public class TeacherTests
    {
        //private Teacher teacher = new Teacher { Id = 1, Name = "Henrik Høltzer", Salary = 1000 };
        //private Teacher teacherNameNull = new Teacher { Id = 2, Name = null, Salary = 1000 };
        //private Teacher teacherNameToShort = new Teacher { Id = 3, Name = "", Salary = 1000 };
        //private Teacher teacherSalaryNegative = new Teacher { Id = 4, Name = "Henrik Høltzer", Salary = -1000 };

        private ITeacher teacher = new Teacher { Id = 1, Name = "Henrik Høltzer", Gender = Person.GenderType.Male, Salary = 1000, Classes = new List<string> { "SWC1.1", "PROG3" } };
        private ITeacher teacherSalaryNegative = new Teacher { Id = 1, Name = "Henrik Høltzer", Gender = Person.GenderType.Male, Salary = -1000, Classes = new List<string> { "SWC1.1", "PROG3" } };
        private ITeacher teacherClassesNull = new Teacher { Id = 1, Name = "Henrik Høltzer", Gender = Person.GenderType.Male, Salary = -1000, Classes = null };
        private ITeacher teacherEquals = new Teacher { Id = 1, Name = "Henrik Høltzer", Gender = Person.GenderType.Male, Salary = 1000, Classes = new List<string> { "SWC1.1", "PROG3" } };

        [TestMethod]
        public void ToStringTest()
        {
            string str = teacher.ToString();
            //Assert.AreEqual("{Id=1, Name=Henrik Høltzer, Salary=1000}", str);
            Assert.AreEqual("{Id=1, Name=Henrik Høltzer, Gender=Male, Salary=1000, Classes=[SWC1.1, PROG3]}", str);
        }

        //[TestMethod]
        //public void ValidateNameTest()
        //{
        //    teacher.ValidateName();
        //    Assert.ThrowsException<ArgumentNullException>(() => teacherNameNull.ValidateName());
        //    Assert.ThrowsException<ArgumentException>(() => teacherNameToShort.ValidateName());
        //}

        [TestMethod]
        public void ValidateSaleryTest()
        {
            teacher.ValidateSalary();
            Assert.ThrowsException<ArgumentOutOfRangeException>(() => teacherSalaryNegative.ValidateSalary());
        }

        [TestMethod]
        public void ValidateClassesTest()
        {
            Assert.ThrowsException<ArgumentNullException>(() => teacherClassesNull.ValidateClasses());
        }

        //Bemærk dette er et alternativ til at benytte de to øvrige ValidateTest metoder 
        [TestMethod]
        public void ValidateTest()
        {
            teacher.Validate();
            //Assert.ThrowsException<ArgumentNullException>(() => teacherNameNull.Validate());
            //Assert.ThrowsException<ArgumentException>(() => teacherNameToShort.Validate());
            Assert.ThrowsException<ArgumentOutOfRangeException>(() => teacherSalaryNegative.Validate());
        }


        [TestMethod]
        public void ValidateEqualsAndHashCodeTest()
        {
            Assert.IsTrue(teacherEquals.Equals(teacher));
            Assert.IsTrue(teacherEquals.GetHashCode() == teacher.GetHashCode());
        }
    }
}
